import org.eclipse.jdt.annotation.NonNull;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.jdt.annotation.NullableByDefault;


@NullableByDefault
public class Annotated {

	public void client(String arg) {
		// GOOD:
		String a = getString(arg, "N/A");
		System.out.println(a.toUpperCase());
		
		// BAD:
		a = getString(null, null);
		a = getStringOrNull();
		a.toUpperCase();
		@NonNull String b = getStringOrNull();
		System.out.println(b.toUpperCase());
	}

	@NonNull String getString(@Nullable String arg, @NonNull String fallback) {
		if (arg != null)
			return arg;
		return fallback;
	}
	
	@Nullable String getStringOrNull() {
		return null;
	}
	
	public 
	@NonNull String implementor(@Nullable String argOrNot, boolean f) {
		if (f)
			System.out.println(argOrNot.toLowerCase());
		return argOrNot;
	}
}

class AnnotatedSub extends Annotated {
	
	@Override
	@Nullable String getString(String arg, @Nullable String fallback) {
		return super.getString(arg, fallback == null ? "" : fallback);
	}
	
	@Override
	@NonNull String getStringOrNull() {
		return "";
	}
	
	@Override
	public String implementor(@NonNull String arg, boolean f) {
		return super.implementor(arg, f);
	}
}
